<?php
	// Require libraries needed for gateway module functions.
	require_once __DIR__ . '/../../../init.php';
	require_once __DIR__ . '/../../../includes/gatewayfunctions.php';
	require_once __DIR__ . '/../../../includes/invoicefunctions.php';

	// Detect module name from filename.
	$gatewayModuleName = basename(__FILE__, '.php');

	// Fetch gateway configuration parameters.
	$gatewayParams = getGatewayVariables($gatewayModuleName);

	// Die if module is not active.
	if (!$gatewayParams['type']) {
	    die("Module Not Activated");
	}

	$success			= false;
	$status				= "";
	$transactionStatus	= "";

	// Retrieve data returned in payment gateway callback
	if(isset($_GET["txncd"]))
	{
		$val			= $gatewayParams['vendorID'];
		$invoiceId		= $_GET['id'];
		$paymentAmount	= $_GET['mc'];
		$paymentFee		= $paymentAmount;
		$transactionId	= $_GET['txncd'];
		$val1			= $_GET['id'];
		$val2			= $_GET['ivm'];
		$val3			= $_GET['qwh'];
		$val4			= $_GET['afd'];
		$val5			= $_GET['poi'];
		$val6			= $_GET['uyt'];
		$val7			= $_GET['ifd'];

		$ipnUrl        = "https://www.ipayafrica.com/ipn/?vendor=".$val."&id=".$val1."&ivm=".$val2."&qwh=".$val3."&afd=".$val4."&poi=".$val5."&uyt=".$val6."&ifd=".$val7;

		if($gatewayParams['testMode'] == 'on') {
			$status = "aei7p7yrx4ae34";
		} else {
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $ipnUrl);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
			$status = curl_exec($ch);
			curl_close($ch);
		}

	}

	switch ($status) {
		case 'aei7p7yrx4ae34':
			$success = true;
			$transactionStatus = "Transaction Successful";
			break;

		case 'fe2707etr5s4wq':
			$transactionStatus = "Transaction Failed";
			break;

		case 'bdi6p2yy76etrs':
			$transactionStatus = "Transaction Pending";
			break;

		case 'dtfi4p7yty45wq':
			$transactionStatus = "Transaction Paid less";
			break;

		case 'eq3i7p5yt7645e':
			$success = true;
			$transactionStatus = "Transaction Paid more";
			break;

		case 'cr5i3pgy9867e1':
			$transactionStatus = "Transaction Transaction Used";
			break;
		
		default:
			$transactionStatus = "Transaction has unexpected results";
			break;
	}

	$isSSL = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off') || $_SERVER['SERVER_PORT'] == 443);
	$whmcsLink = 'http' . ($isSSL ? 's' : '') . '://' . $_SERVER['HTTP_HOST'] . substr(str_replace('/admin/', '/', $_SERVER['REQUEST_URI']), 0, strrpos($_SERVER['REQUEST_URI'], '/'));

	/**
	 * Validate Callback Invoice ID.
	 *
	 * Checks invoice ID is a valid invoice number. Note it will count an
	 * invoice in any status as valid.
	 *
	 * Performs a die upon encountering an invalid Invoice ID.
	 *
	 * Returns a normalised invoice ID.
	 *
	 * @param int $invoiceId Invoice ID
	 * @param string $gatewayName Gateway Name
	 */
	$invoiceId = checkCbInvoiceID($invoiceId, $gatewayParams['name']);


	/**
	 * Check Callback Transaction ID.
	 *
	 * Performs a check for any existing transactions with the same given
	 * transaction number.
	 *
	 * Performs a die upon encountering a duplicate.
	 *
	 * @param string $transactionId Unique Transaction ID
	 */
	checkCbTransID($transactionId);


	/**
	 * Log Transaction.
	 *
	 * Add an entry to the Gateway Log for debugging purposes.
	 *
	 * The debug data can be a string or an array. In the case of an
	 * array it will be
	 *
	 * @param string $gatewayName        Display label
	 * @param string|array $debugData    Data to log
	 * @param string $transactionStatus  Status
	 */
	logTransaction($gatewayParams['name'], $_GET, $transactionStatus);

	if ($success) {
	    /**
	     * Add Invoice Payment.
	     *
	     * Applies a payment transaction entry to the given invoice ID.
	     *
	     * @param int $invoiceId         Invoice ID
	     * @param string $transactionId  Transaction ID
	     * @param float $paymentAmount   Amount paid (defaults to full balance)
	     * @param float $paymentFee      Payment fee (optional)
	     * @param string $gatewayModule  Gateway module name
	     */
	    addInvoicePayment(
	        $invoiceId,
	        $transactionId,
	        $paymentAmount,
	        $paymentFee,
	        $gatewayModuleName
	    );

	}

	$invoice_url = $whmcsLink . '/../../../viewinvoice.php?id=' . rawurlencode($invoiceId);
    header('Location: '.$invoice_url);
    die();
	exit;


?>